## API Report File for "@uifabricshared/foundation-composable"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { ISlotProps } from '@uifabricshared/foundation-settings';
import * as React from 'react';

// @public
export function atomic<TProps extends object, TState = object>(target: INativeSlotType, usePrepareProps: IComposable<TProps, ISlotProps<TProps>, TState>['usePrepareProps'], filter?: IPropFilter): React.FunctionComponent<TProps>;

// @public (undocumented)
export function atomicRender<TProps extends object, TState = object>(Slots: ISlots<ISlotProps<TProps>>, _renderData: IRenderData<ISlotProps<TProps>, TState>, ...children: React.ReactNode[]): JSX.Element | null;

// @public (undocumented)
export function atomicUsePrepareProps<TProps extends object, TSlotProps extends ISlotProps = ISlotProps<TProps>, TState = object>(props: TProps, useStyling: IUseStyling<TProps, TSlotProps>): IRenderData<TSlotProps, TState>;

// @public
export function composable<TProps extends object, TSlotProps extends ISlotProps = ISlotProps<TProps>, TState = object>(options: IComposableDefinition<TProps, TSlotProps, TState>): IWithComposable<React.FunctionComponent<TProps>, IComposable<TProps, TSlotProps, TState>>;

// @public
export interface IComposable<TProps extends object, TSlotProps extends ISlotProps = ISlotProps<TProps>, TState = object> {
    render: (Slots: ISlots<TSlotProps>, renderData: IRenderData<TSlotProps, TState>, ...children: React.ReactNode[]) => JSX.Element | null;
    slots: ISlotDefinitions<TSlotProps>;
    usePrepareProps: (props: TProps, useStyling: IUseStyling<TProps, TSlotProps>) => IRenderData<TSlotProps, TState>;
    useStyling: IUseStyling<TProps, TSlotProps>;
}

// @public (undocumented)
export type IComposableDefinition<TProps extends object, TSlotProps extends ISlotProps = ISlotProps<TProps>, TState = any> = Partial<IComposable<TProps, TSlotProps, TState>>;

// @public
export type INativeSlotType = React.ElementType<any> | string;

// @public
export type IPropFilter = (propName: string) => boolean;

// @public
export interface IRenderData<TSlotProps extends ISlotProps, TState = any> {
    // (undocumented)
    slotProps?: TSlotProps;
    // (undocumented)
    state?: TState;
}

// @public
export type ISlotDefinitions<TSlotProps extends ISlotProps> = {
    [K in keyof TSlotProps]: ISlotWithFilter;
};

// @public
export type ISlots<TSlotProps extends ISlotProps> = {
    [K in keyof TSlotProps]: React.FunctionComponent<TSlotProps[K]>;
};

// @public
export type ISlotWithFilter<TMixin = object> = {
    slotType?: INativeSlotType;
    filter?: IPropFilter;
} & TMixin;

// @public (undocumented)
export type IUseStyling<TProps extends object, TSlotProps extends ISlotProps = ISlotProps<TProps>> = (props: TProps) => TSlotProps;

// @public
export type IWithComposable<T extends object = object, TComposable = IComposable<object>> = T & {
    __composable: TComposable;
};

// Warning: (ae-forgotten-export) The symbol "ISlotFn" needs to be exported by the entry point index.d.ts
// 
// @public
export function renderSlot<TProps>(slot: INativeSlotType | ISlotFn<TProps>, extraProps: TProps, ...children: React.ReactNode[]): React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)>) | (new (props: any) => React.Component<any, any, any>)>;

// @public
export function withSlots<P>(reactType: INativeSlotType, props?: React.Attributes & P | null, ...children: React.ReactNode[]): ReturnType<React.FunctionComponent<P>>;


// (No @packageDocumentation comment for this package)

```
