import * as React from 'react';
import { IRenderData, IComposable, ISlots } from './Composable.types';
import { ISlotProps } from '@uifabricshared/foundation-settings';
export declare type ISlotFn<TProps> = React.FunctionComponent<TProps> & {
    _canCompose?: boolean;
};
/**
 * Driver function for the prop preparation phase of rendering a composable control
 *
 * @param props - user props send to prepare props
 * @param composable - composable for this component
 */
export declare function useCompoundPrepare<TProps, TSlotProps extends ISlotProps, TState>(props: TProps, composable: IComposable<TProps, TSlotProps, TState>): {
    renderData: IRenderData<TSlotProps, TState>;
    Slots: ISlots<TSlotProps>;
};
//# sourceMappingURL=Composable.slots.d.ts.map